program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils, Strutils;

var ifile, ofile: TextFile;
   Yv,np,i,j,N,h, L, ns,s: LongInt;
   sa:array [0..200] of real;
   ss:real;
   x,y,minim:array[0..5000] of longint;


function sum(x,y:array of integer;start,fin:integer):real;
var i:integer;
begin ss:=0;
  for i:=start to fin-1 do
  ss:=ss+y[i]*(x[i+1]-x[i])+0.5*(y[i+1]-y[i])*(x[i+1]-x[i]);
  ss:=ss-0.5*abs((y[start]-y[fin])*(x[start]-x[fin]));
result:=ss;
end;



begin

  AssignFile(ifile, 'input.txt');
  Reset(ifile);
  Read(ifile, N, L);
  readln(ifile);
  For i:=0 to N-1 do  Read(ifile, X[i], y[i]);
  CloseFile(ifile);
  Yv:= y[0]; np:=0;
  for i:=0 to n-1 do
      if Yv>y[i] then  Yv:=y[i];
  for i:=0 to n-1 do
  if y[i]=yv then  begin minim[np]:=i; inc(np);end;
  ss:=0;
  for i:=0 to np-1 do
  for j:=0 to n do begin
    IF sqrt(sqr(X[i]-X[j])+sqr(y[i]-Y[j]))>L then continue;
    sa[j]:=sum(x,y,i,j);
   end;



  for i:=0 to n do
  if ss<sa[i] then ss:= sa[i];


  AssignFile(ofile, 'output.txt');
  Rewrite(ofile);
  Write(ofile,round (ss));
  CLoseFile(ofile);














      {for h:=0 to n-1 do begin
  if y[h]=Yv then continue
  else begin m:=h; xV:=x[h]; end;

  For i:= 0 to m-1 do begin
       if sqrt(sqr(X[i]-Xv)+sqr(y[i]-Yv))>L then continue;
       ss:=0;
       for j:=i to M-1 do begin
        if (y[i]-Yv)/(x[i]-Xv)*x[j]+Yv > y[j] then begin
                ss:=0; break; end;
        if (y[i]-Yv)/(x[i]-Xv)*x[j+1]+Yv > y[j+1] then begin
                ss:=0; break; end;
     ss:=ss+y[j]*(x[j+1]-x[j])+0.5*(x[j+1]-x[j])*(y[j+1]-y[j]);
     end;
     if ss<>0 then begin ss:=ss-y[i]*(Xv-x[i])-0.5*(Xv-x[i])*(Yv-y[i]);
                        sa[ns]:=ss;
                        inc(ns); end;
  end;
  For i:= m+1 to n-1 do begin
       if sqrt(sqr(X[i]-Xv)+sqr(y[i]-Yv))>L then continue;
       ss:=0;
       for j:=i downto M+1 do begin
        if (y[i]-Yv)/(x[i]-Xv)*x[j]+Yv > y[j] then begin
                ss:=0; break; end;
        if (y[i]-Yv)/(x[i]-Xv)*x[j-1]+Yv > y[j-1] then begin
                ss:=0; break; end;
     ss:=ss+y[j-1]*(x[j]-x[j-1])+0.5*(x[j]-x[j-1])*(y[j]-y[j-1]);
     end;
     if ss<>0 then begin ss:=ss-Yv*(x[i]-Xv)-0.5*(x[i]-Xv)*(y[i]-Yv);
                        sa[ns]:=ss;
                        inc(ns); end;
  end;
  end;
  ss:=sa[0];
  for i:=1 to ns do
  if ss<sa[i] then ss:= sa[i];


  AssignFile(ofile, 'output.txt');
  Rewrite(ofile);
  Write(ofile,round (ss));
  CLoseFile(ofile);
      }
end.
